var SEARCH_ELEM_ID = "go";
var RESULTS_ELEM_ID = "results";
var API_URL = "wikiapi.php";

var TYPING_DELAY = 500;
var NUM_RESULTS = 5;

$(document).ready(function () {
	$("#"+SEARCH_ELEM_ID).keyup(function() {
		var $me = $(this);
		clearTimeout($me.data("timer"));
		var val = $me.val();
		if (val.length < 1) {
			$("#"+RESULTS_ELEM_ID).html("");
		} else {
			var wait = setTimeout(function () {search(val);}, TYPING_DELAY);
			$me.data("timer", wait);
		}
	});
	$("a").live('touchstart touchend', function() {
		$(this).toggleClass('touch');
	});
	adjustHeight();
});
function adjustHeight() {
	window.scrollTo(0, 1);
	setTimeout(function () {$("body").height($(window).height());}, 1000);
}
function search(term) {
	$("#"+SEARCH_ELEM_ID).toggleClass("loading");
	$.ajax({
		url: API_URL,
		type: "GET",
		data: {
			action: "opensearch",
			limit: NUM_RESULTS,
			namespace: 0,
			format: "xml",
			search: term
		},
		success: function(data) {
			var $xml = $(data);
			var objs = new Array();
			$xml.find("Item").each(function () {
				var $me = $(this);
				var obj = {
					label: $me.find("Text").text(),
					value: $me.find("Url").text()
				}
				objs.push(obj);
			});
			
			writeResults(objs);
			$("#"+SEARCH_ELEM_ID).toggleClass("loading");
		}
	});
}
function writeResults(objs) {
	if (!objs || objs.length < 1) {
		$("#"+RESULTS_ELEM_ID).html("<ul><li style='border-bottom:none !important;'>No results returned</li></ul>");
	} else {
		$("#"+RESULTS_ELEM_ID).html("<ul></ul>");
		var $list = $("ul", $("#"+RESULTS_ELEM_ID));
		for (i = 0; i < objs.length; i++) {
			var obj = objs[i];
			$list.append("<li><a href='" + obj.value + "'>" + obj.label + "</a></li>");
		}
	}
}